/*
** File_parser.h
** 
** Made by damien
** Login   <damien@ortie>
** 
** Started on  Fri Jan 25 19:23:33 2008 damien
** Last update Fri Jan 25 19:23:33 2008 damien
*/

#ifndef   	FILE_PARSER_H_
# define   	FILE_PARSER_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
using namespace std;


#include <Mesh.h>
#include <Curve_3D.h>
#include <Skinned.h>
#include <Skeleton.h>

#include <tinyXml/tinyxml.h>
#include <tinyXml/tinystr.h>


class File_parser
{
 public:

  File_parser();
  ~File_parser();

  int load_file(const char* filename,const char* extension,Mesh *mesh) const;
  int load_file(const std::string& filename,const std::string& extension,Mesh *mesh) const;
  int load_file(const std::string& filename,const char* extension,Mesh *mesh) const;
    
  int write_file(const char* filename,const char* extension,const Mesh& mesh) const;
  int write_file(const std::string& filename,const std::string& extension,const Mesh& mesh) const;
  int write_file(const std::string& filename,const char* extension,const Mesh& mesh) const;
 


  int load_obj_mesh(const char* filename,Mesh *mesh) const;
  int save_obj_mesh(const char* filename,const Mesh &mesh) const;

  int load_off_mesh(const char* filename,Mesh *mesh) const;
  int save_off_mesh(const char* filename,const Mesh &mesh) const;

  int load_collada_mesh(const char* filename,const char* mesh_name,Mesh *mesh) const;

  int save_rib_mesh(const char* filename,const Mesh &mesh) const;

  int save_curve(const char* filename,const Mesh& mesh,const std::vector<int>& boundary_index) const;
  int load_curve(const char* filename,Curve_3D* curve) const;



  int load_collada_skeleton(const char* filename,const char* skeleton_name,Skeleton *skeleton) const;
  int load_collada_animation(const char* filename,Skeleton *skeleton) const;
  int load_collada_skining_attribute(const char* filename, Skinned *skinned) const;

  int save_skeleton_sk(const char* filename,Skeleton &skeleton) const;
  int load_old_sk_skeleton(const char *filename,Skeleton *skeleton) const;//old

  int load_g_mesh(const char* filename,Mesh *mesh) const;
  int save_g_mesh(const char* filename,const Mesh& mesh) const;

 private:

  int reccursive_skeleton_collada_reading_node(TiXmlHandle &current_node,Joint *current) const;
  
};


#endif 	    /* !FILE_PARSER_H_ */
