/*
** OpenGL_drawer.h
** 
** Made by damien
** Login   <damien@ortie>
** 
** Started on  Sat Jan 26 10:34:05 2008 damien
** Last update Sat Jan 26 10:34:05 2008 damien
*/

#ifndef   	OPENGL_DRAWER_H_
# define   	OPENGL_DRAWER_H_


#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>
#include <GL/glut.h>
#include <GL/glext.h>
using namespace std;

#include <Navigator_tool.h>
#include <Mesh.h>
#include <Skeleton.h>
#include <Skinned.h>

class OpenGL_drawer
{

 public:

  OpenGL_drawer();
  ~OpenGL_drawer();


  int draw_mesh(Mesh& mesh);
  int draw_skeleton(Skeleton &);
  
  int draw_triangles(Mesh& mesh);
  int init_opengl(int arc,char **argv,const Navigator_tool& navigator);
  int draw_local_basis(Navigator_tool& navigator);
  int draw_selected_bone(Skeleton &skeleton,int selected_joint);

 private:
  
  std::vector <GLint> draw_list;
  
  std::vector <GLfloat> current_color;
  int set_current_color(int k_bone);
  
  
};

#endif 	    /* !OPENGL_DRAWER_H_ */
